(function(){

    console.log("WebViewShareContent--初始化");

//    if(window.WebAppShare){
//        console.log("WebViewShareContent--已存在");
//        return;
//    }

    function collectLink(){
        var link = collectMeta('og:url', true);
        if (!nonEmptyString(link)) {
            link = window.location.href;
        }
        return link;
    }

    function collectTitle(){
        let metaTitle = collectMeta('og:title',true);
        if (!metaTitle) {
            if (nonEmptyString(document.title)) {
                metaTitle = contentTidy(document.title);
            } else {
                if (document.getElementsByTagName("H1").length > 0 && document.getElementsByTagName("H1")[0].textContent.length > 0) {
                    metaTitle = nodeStrFlitter(document.getElementsByTagName("H1")[0]);
                }
            }
        }
        return metaTitle;
    }

    function collectDesc(){
        var metaDesc = collectMeta('og:description',true);
        if (!metaDesc) {
            metaDesc = collectMeta('description',false);
        }
        if (!metaDesc) {
            metaDesc = collectMeta('Description',false);
        }
        if (!metaDesc) {
            metaDesc = '';
        }
        return contentTidy(metaDesc);
    }

    function collectIcon(){
        var metaImg  = collectMeta('og:image', true);
        if (!metaImg) {
            // 找icon
            var iconImgNode = document.querySelector('link[rel=\"icon\"]');
            if (!iconImgNode) {
                iconImgNode = document.querySelector('link[rel=\"shortcut icon\"]');
            }
            if (!iconImgNode) {
                iconImgNode = document.querySelector('link[type="image/x-icon"]');
            }
            if (iconImgNode && iconImgNode.getAttribute("href")) {
                metaImg = getAbsoluteUrl(iconImgNode.getAttribute("href"));
            }else {
                // 找到所有img并使用第一个
                let imgs = document.getElementsByTagName('img');
                if (imgs && imgs.length > 0)  {
                    metaImg = getAbsoluteUrl(imgs[0].src);
                }
            }
        }
        return metaImg;
    }

    function contentTidy(str){
        return str.replace(/\s{4}/g, " ").replace(/(\r|\n)/g, "").trim();
    }

    function collectMeta(metaName, fromOG){
        var propertyName = metaName;
        if (fromOG) {
            propertyName = 'meta[property="' + metaName + '"]';
        }else {
            propertyName = 'meta[name="' + metaName + '"]';
        }
        var value;
        var metaLinkNode = document.querySelector(propertyName);
        if (metaLinkNode) {
            value = metaLinkNode.getAttribute('content');
        }
        return value;
    }

    function nodeStrFlitter(element, imgAlt){
       imgAlt = imgAlt || true;
       tmp = element.cloneNode(true);
       if (imgAlt) {
         Array.prototype.forEach.call(tmp.querySelectorAll("img[alt]"), function(el) {
           el.parentNode.replaceChild(document.createTextNode(el.alt), el);
         });
       }
       Array.prototype.forEach.call(tmp.querySelectorAll("script,style,link"), function(el) {
         el.parentNode.replaceChild(document.createTextNode(""), el);
       });
       tmp = contentTidy(tmp.textContent);
       return tmp;
    }

    function getAbsoluteUrl(url){
        var a = document.createElement('A');
        a.href = url;
        url = a.href;
        return url;
    }

    function nonEmptyString(str){
      return str && str.trim() !== "";
    }

    var shareContent = {
        title:collectTitle(),
        icon:collectIcon(),
        url:collectLink(),
        desc:collectDesc(),
    };

    window.WebAppShare = shareContent;
    console.log("WebViewShareContent--初始化完成");

})();
